%   By Feng Cai, Double Resampling
%   Oct.25,2009
%   Test GSMO for MTL package on Wisconsin breast cancer dataset

clear all;

[data] = textread('breast_cancer_wisconsin.data','','delimiter',',');
step = 1;
% # of rows
N1 = size(data, 1);

% # of columns
N2 = size(data,2);

alldata = [];
for i = 1:N1
    if size(find(data(i,:)<0),2)<1
        alldata = [alldata; data(i,2:N2)];
    end
end

%alldata = [heart(:,1) heart(:,3:N2-1) heart(:,2) heart(:,N2)];
N1 = size(alldata,1);
N2 = size(alldata,2);

% order all data by increasing age
alldata = sortrows(alldata);
alldatag = alldata;
%alldatag = sortrows(alldatag);
%alldata = [alldatag(:,2:N2-1) alldatag(:,1) alldatag(:,N2)];
%alldatag = alldata;

for i = 1:N2-1
    tmp1 = min(alldata(:,i));
    tmp2 = max(alldata(:,i));
    alldata(:,i) = (alldata(:,i)-tmp1)/(tmp2-tmp1);
end

train = [];
test = [];

finalaccuracy_mtl = [];


C_SVMmtl = zeros(5,1);
gama_SVMmtl = zeros(5,1);
sigma_SVMmtl = zeros(5,1);

options.ker = [0 1];
options.arg = [10 5];
options.gamma = 0.1;
options.C = 100;

t = cputime;
% outer loop, resampling
for i = 1:5
    testindex = [];
    trainindex = [];
    % compute the index
    for j = 1:N1
        if mod(j,5)==mod(i,5)
            testindex = [testindex j];
        else
            trainindex = [trainindex j];
        end
    end
    train = alldata(trainindex,:);
    
    test = alldata(testindex,:);
    
    % construct the test data
    testdata(1).X = [];
    testdata(1).y = [];
    
    testdata(2).X = [];
    testdata(2).y = [];
    testdata(3).X = [];
    testdata(3).y = [];
    traindata(1).X = [];
    traindata(1).y = [];
    
    traindata(2).X = [];
    traindata(2).y = [];
    traindata(3).X = [];
    traindata(3).y = [];
    
    for j = 1:size(test,1)
        if test(j,1)<0.23
            testdata(2).X = [testdata(2).X; test(j,1:N2-1)];
            if test(j,N2)==2
                testdata(2).y = [testdata(2).y; 1];
            else
                testdata(2).y = [testdata(2).y; -1];
            end
        elseif test(j,1)<0.5
            testdata(1).X = [testdata(1).X; test(j,1:N2-1)];
            if test(j,N2)==2
                testdata(1).y = [testdata(1).y; 1];
            else
                testdata(1).y = [testdata(1).y; -1];
            end
        else
            testdata(3).X = [testdata(3).X; test(j,1:N2-1)];
            if test(j,N2)==2
                testdata(3).y = [testdata(3).y; 1];
            else
                testdata(3).y = [testdata(3).y; -1];
            end
        end
        
    end
    
    for j = 1:size(train,1)
        if train(j,1)<0.23
            traindata(2).X = [traindata(2).X; train(j,1:N2-1)];
            if train(j,N2)==2
                traindata(2).y = [traindata(2).y; 1];
            else
                traindata(2).y = [traindata(2).y; -1];
            end          
        elseif train(j,1)<0.5
            traindata(1).X = [traindata(1).X; train(j,1:N2-1)];
            if train(j,N2)==2
                traindata(1).y = [traindata(1).y; 1];
            else
                traindata(1).y = [traindata(1).y; -1];
            end
        else
            traindata(3).X = [traindata(3).X; train(j,1:N2-1)];
            if train(j,N2)==2
                traindata(3).y = [traindata(3).y; 1];
            else
                traindata(3).y = [traindata(3).y; -1];
            end
        end      
        
    end
    
    % resampling to tune the model parameter
    C = [0.1 1 10 100];
    gama = [10 1 0.1 0.01 0.001];
    sigma = [0.25 0.5 1 2 4];
   
    maxaccuracy_mtl = 0;
    
    C_optmtl = 0.1;
   
    gama_optmtl = 10;
    
    sigma_optmtl = 0.25;
    
    
    
    for inx1 = 1:size(C,2)
        for inx2 = 1:size(gama,2)
            for inx3 = 1:size(sigma,2)
                % setting paramters
                options.arg(2) = sigma(inx3);
                options.gamma = gamma(inx2);
                options.C = C(inx1);
                step 
                step = step + 1;
                N3 = size(train, 1);
        
                accuracy = [];
                accuracy_plus = [];
                accuracy_mtl = [];
        
                for j = 1:5
                    testindex = [];
                    trainindex = [];
        
                    for k = 1:N3
                        if mod(k,5)==mod(j,5)
                            testindex = [testindex k];
                        else
                            trainindex = [trainindex k];
                        end
                    end
        
                    traintmp = train(trainindex,:);
                    testtmp = train(testindex,:);
        
                    traintune(1).X = [];
                    traintune(1).y = [];
                    traintune(2).X = [];
                    traintune(2).y = [];
                    traintune(3).X = [];
                    traintune(3).y = [];
                    testtune(1).X = [];
                    testtune(1).y = [];
                    testtune(2).X = [];
                    testtune(2).y = [];
                    testtune(3).X = [];
                    testtune(3).y = [];
        
                    for k = 1:size(traintmp,1)
                        if traintmp(k,1)<0.23
                            traintune(2).X = [traintune(2).X; traintmp(k,1:N2-1)];
                            if traintmp(k,N2)==2
                                traintune(2).y = [traintune(2).y; 1];
                            else
                                traintune(2).y = [traintune(2).y; -1];
                            end
                        elseif traintmp(k,1)<0.5
                            traintune(1).X = [traintune(1).X; traintmp(k,1:N2-1)];
                            if traintmp(k,N2)==2
                                traintune(1).y = [traintune(1).y; 1];
                            else
                                traintune(1).y = [traintune(1).y; -1];
                            end
                        else
                            traintune(3).X = [traintune(3).X; traintmp(k,1:N2-1)];
                            if traintmp(k,N2)==2
                                traintune(3).y = [traintune(3).y; 1];
                            else
                                traintune(3).y = [traintune(3).y; -1];
                            end
                        end
                                           
                    end
        
                    for k = 1:size(testtmp,1)
                        if testtmp(k,1)<0.23
                            testtune(2).X = [testtune(2).X; testtmp(k,1:N2-1)];
                            if testtmp(k,N2)==2
                                testtune(2).y = [testtune(2).y; 1];
                            else
                                testtune(2).y = [testtune(2).y; -1];
                            end
                        elseif testtmp(k,1)<0.5
                            testtune(1).X = [testtune(1).X; testtmp(k,1:N2-1)];
                            if testtmp(k,N2)==2
                                testtune(1).y = [testtune(1).y; 1];
                            else
                                testtune(1).y = [testtune(1).y; -1];
                            end
                        else
                            testtune(3).X = [testtune(3).X; testtmp(k,1:N2-1)];
                            if testtmp(k,N2)==2
                                testtune(3).y = [testtune(3).y; 1];
                            else
                                testtune(3).y = [testtune(3).y; -1];
                            end
                        end
                                              
                    end
                   
                    
                    
                    
                    model = smomtl(traintune, options);
                    [pred, pred_error] = predsmomtl(testtune, model);
                    accuracy_mtl = [accuracy_mtl; 1-pred_error];
                end
               
                 if maxaccuracy_mtl<mean(accuracy_mtl)
                     maxaccuracy_mtl = mean(accuracy_mtl);
                     C_optmtl = options.C;
                     gama_optmtl = options.gamma;
                     sigma_optmtl = options.arg(2);
                 end
            end
        end
    end
    
    options.arg(2) = sigma_optmtl;
    options.gamma = gama_optmtl;
    options.C = C_optmtl;
    C_SVMmtl(i,1) = C_optmtl;
    gama_SVMmtl(i,1) = gama_optmtl;
    sigma_SVMmtl(i,1) = sigma_optmtl;
    model = smomtl(traindata, options);
    [pred, pred_error] = predsmomtl(testdata, model);
    finalaccuracy_mtl = [finalaccuracy_mtl; 1-pred_error];
end

runningtime = cputime - t;

fid = fopen('result_cancer_smomtl.csv','wt');
fprintf(fid, '%s,', 'Folds');
for i = 1:5
    fprintf(fid,'%s,', num2str(i));
end
fprintf(fid, '%s,', 'Mean');
fprintf(fid, '%s\n', 'variance');



fprintf(fid, '%s,', 'svm+MTL');
for i = 1:5
    fprintf(fid, '%s,', num2str(finalaccuracy_mtl(i,1)));
end
fprintf(fid, '%s,', num2str(mean(finalaccuracy_mtl)));
fprintf(fid, '%s\n', num2str(std(finalaccuracy_mtl)));

fprintf(fid, '%s,', 'C');
for i = 1:4
    fprintf(fid, '%s,', num2str(C_SVMmtl(i,1)));
end
fprintf(fid, '%s\n', num2str(C_SVMmtl(5,1)));

fprintf(fid, '%s,', 'gama');%
for i = 1:4
    fprintf(fid, '%s,', num2str(gama_SVMmtl(i,1)));
end
fprintf(fid, '%s\n', num2str(gama_SVMmtl(5,1)));

fprintf(fid, '%s,', 'sigma');
for i = 1:4
    fprintf(fid, '%s,', num2str(sigma_SVMmtl(i,1)));
end
fprintf(fid, '%s\n', num2str(sigma_SVMmtl(5,1)));

fprintf(fid, 'runningtime, %s\n', num2str(runningtime));

fclose(fid);