function [pred, pred_error] = predsmomtl(test, model)

% to compute the prdicted labels and prediction error using models
% from generalized SMO for MTL.
% by Feng Cai, Oct.24,2009
%
% Inputs:
%   test
%     test(1), test(2), ... test(t): binary labeled training vectors for 
%     different groups.
%   test(1) [struct] Binary labeled training vectors for group r:
%     .X [num_data x dim] Training vectors.
%     .y [num_data x 1] Labels (1 or -1).
%   model
%     model trained by smomtl
%
% Outputs:
%   pred 
%     pred(1), pred(2), ... pred(t): predicted labels for different groups. 
%   pred_error
%     prediction error on test set.

options = model.options;
[pred_label, pred_error] = predsmomtl_mex(test,options.ker,options.arg,...
    options.gamma,options.C,model.Alpha,model.groupid,model.d,...
    model.svX,model.svy,model.nsv);

for i = 1:pred_label(size(pred_label,1),2)
    inx = find(pred_label(:,2)==i);
    pred(i).y = pred_label(inx,1);
end